diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/netanim/model/animation-interface.cc ns-3.31/src/netanim/model/animation-interface.cc
--- ns-3.30.1/src/netanim/model/animation-interface.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/netanim/model/animation-interface.cc	2020-06-27 17:38:30.000000000 -0700
@@ -2093,7 +2133,7 @@
   return;
 }
 
-void 
+void
 AnimationInterface::CheckMaxPktsPerTraceFile ()
 {
   // Start a new trace file if the current packet count exceeded nax packets per file
@@ -2106,10 +2146,10 @@
   StopAnimation (true);
 }
 
-std::string 
+std::string
 AnimationInterface::GetNetAnimVersion ()
 {
-  return NETANIM_VERSION; 
+  return NETANIM_VERSION;
 }
 
 
@@ -2191,7 +2231,7 @@
 
 /***** Routing-related *****/
 
-void 
+void
 AnimationInterface::TrackIpv4RoutePaths ()
 {
   if (m_ipv4RouteTrackElements.empty ())
@@ -2238,7 +2278,7 @@
         }
       std::ostringstream oss;
       oss << rt->GetGateway ();
-      NS_LOG_INFO ("Node:" << trackElement.fromNodeId << "-->" << rt->GetGateway ()); 
+      NS_LOG_INFO ("Node:" << trackElement.fromNodeId << "-->" << rt->GetGateway ());
       if (rt->GetGateway () == "0.0.0.0")
         {
           Ipv4RoutePathElement elem = { trackElement.fromNodeId, "C" };
@@ -2265,7 +2305,7 @@
 
 }
 
-void 
+void
 AnimationInterface::TrackIpv4Route ()
 {
   if (Simulator::Now () > m_routingStopTime)
@@ -2293,7 +2333,7 @@
   Simulator::Schedule (m_routingPollInterval, &AnimationInterface::TrackIpv4Route, this);
 }
 
-std::string 
+std::string
 AnimationInterface::GetIpv4RoutingTable (Ptr <Node> n)
 {
 
@@ -2311,7 +2351,7 @@
 
 }
 
-void 
+void
 AnimationInterface::RecursiveIpv4RoutePathSearch (std::string from, std::string to, Ipv4RoutePathElements & rpElements)
 {
   NS_LOG_INFO ("RecursiveIpv4RoutePathSearch from:" << from.c_str () << " to:" << to.c_str ());
@@ -2374,7 +2414,7 @@
         }
       return;
     }
-  NS_LOG_INFO ("Node:" << fromNode->GetId () << "-->" << rt->GetGateway ()); 
+  NS_LOG_INFO ("Node:" << fromNode->GetId () << "-->" << rt->GetGateway ());
   Ipv4RoutePathElement elem = { fromNode->GetId (), oss.str () };
   rpElements.push_back (elem);
   RecursiveIpv4RoutePathSearch (oss.str (), to, rpElements);
@@ -2385,7 +2425,7 @@
 
 /***** WriteXml *****/
 
-void 
+void
 AnimationInterface::WriteXmlAnim (bool routing)
 {
   AnimXmlElement element ("anim");
@@ -2403,10 +2443,10 @@
   WriteN (element.ToString (false) + ">\n", f);
 }
 
-void 
-AnimationInterface::WriteXmlClose (std::string name, bool routing) 
+void
+AnimationInterface::WriteXmlClose (std::string name, bool routing)
 {
-  std::string closeString = "</" + name + ">\n"; 
+  std::string closeString = "</" + name + ">\n";
   if (!routing)
     {
       WriteN (closeString, m_f);
@@ -2417,7 +2457,7 @@
     }
 }
 
-void 
+void
 AnimationInterface::WriteXmlNode (uint32_t id, uint32_t sysId, double locX, double locY)
 {
   AnimXmlElement element ("node");
@@ -2428,7 +2468,7 @@
   WriteN (element.ToString (), m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlUpdateLink (uint32_t fromId, uint32_t toId, std::string linkDescription)
 {
   AnimXmlElement element ("linkupdate");
@@ -2439,14 +2479,14 @@
   WriteN (element.ToString (), m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlLink (uint32_t fromId, uint32_t toLp, uint32_t toId)
 {
   AnimXmlElement element ("link");
   element.AddAttribute ("fromId", fromId);
   element.AddAttribute ("toId", toId);
 
-  LinkProperties lprop ;
+  LinkProperties lprop;
   lprop.fromNodeDescription = "";
   lprop.toNodeDescription = "";
   lprop.linkDescription = "";
@@ -2461,10 +2501,10 @@
     {
       lprop = m_linkProperties[p2];
     }
-  
-  element.AddAttribute ("fd", lprop.fromNodeDescription, true); 
-  element.AddAttribute ("td", lprop.toNodeDescription, true); 
-  element.AddAttribute ("ld", lprop.linkDescription, true); 
+
+  element.AddAttribute ("fd", lprop.fromNodeDescription, true);
+  element.AddAttribute ("td", lprop.toNodeDescription, true);
+  element.AddAttribute ("ld", lprop.linkDescription, true);
   WriteN (element.ToString (), m_f);
 }
 
@@ -2479,7 +2519,7 @@
     {
       AnimXmlElement valueElement ("address");
       valueElement.SetText (*i);
-      element.AppendChild(valueElement);
+      element.AppendChild (valueElement);
     }
   WriteN (element.ToString (), m_f);
 }
@@ -2488,7 +2528,7 @@
 AnimationInterface::WriteXmlIpv6Addresses (uint32_t nodeId, std::vector<std::string> ipv6Addresses)
 {
   AnimXmlElement element ("ipv6");
-  element.AddAttribute("n", nodeId);
+  element.AddAttribute ("n", nodeId);
   for (std::vector<std::string>::const_iterator i = ipv6Addresses.begin ();
        i != ipv6Addresses.end ();
        ++i)
@@ -2497,10 +2537,10 @@
       valueElement.SetText (*i);
       element.AppendChild (valueElement);
     }
-  WriteN(element.ToString (), m_f);
+  WriteN (element.ToString (), m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlRouting (uint32_t nodeId, std::string routingInfo)
 {
   AnimXmlElement element ("rt");
@@ -2510,7 +2550,7 @@
   WriteN (element.ToString (), m_routingF);
 }
 
-void 
+void
 AnimationInterface::WriteXmlRp (uint32_t nodeId, std::string destination, Ipv4RoutePathElements rpElements)
 {
   std::string tagName = "rp";
@@ -2533,7 +2573,7 @@
 }
 
 
-void 
+void
 AnimationInterface::WriteXmlPRef (uint64_t animUid, uint32_t fId, double fbTx, std::string metaInfo)
 {
   AnimXmlElement element ("pr");
@@ -2547,7 +2587,7 @@
   WriteN (element.ToString (),  m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlP (uint64_t animUid, std::string pktType, uint32_t tId, double fbRx, double lbRx)
 {
   AnimXmlElement element (pktType);
@@ -2558,9 +2598,9 @@
   WriteN (element.ToString (),  m_f);
 }
 
-void 
-AnimationInterface::WriteXmlP (std::string pktType, uint32_t fId, double fbTx, double lbTx, 
-                                                   uint32_t tId, double fbRx, double lbRx, std::string metaInfo)
+void
+AnimationInterface::WriteXmlP (std::string pktType, uint32_t fId, double fbTx, double lbTx,
+                               uint32_t tId, double fbRx, double lbRx, std::string metaInfo)
 {
   AnimXmlElement element (pktType);
   element.AddAttribute ("fId", fId);
@@ -2576,7 +2616,7 @@
   WriteN (element.ToString (),  m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlAddNodeCounter (uint32_t nodeCounterId, std::string counterName, CounterType counterType)
 {
   AnimXmlElement element ("ncs");
@@ -2586,7 +2626,7 @@
   WriteN (element.ToString (), m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlAddResource (uint32_t resourceId, std::string resourcePath)
 {
   AnimXmlElement element ("res");
@@ -2595,7 +2635,7 @@
   WriteN (element.ToString (), m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlUpdateNodeImage (uint32_t nodeId, uint32_t resourceId)
 {
   AnimXmlElement element ("nu");
@@ -2606,7 +2646,7 @@
   WriteN (element.ToString (), m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlUpdateNodeSize (uint32_t nodeId, double width, double height)
 {
   AnimXmlElement element ("nu");
@@ -2618,7 +2658,7 @@
   WriteN (element.ToString (),  m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlUpdateNodePosition (uint32_t nodeId, double x, double y)
 {
   AnimXmlElement element ("nu");
@@ -2630,7 +2670,7 @@
   WriteN (element.ToString (), m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlUpdateNodeColor (uint32_t nodeId, uint8_t r, uint8_t g, uint8_t b)
 {
   AnimXmlElement element ("nu");
@@ -2643,7 +2683,7 @@
   WriteN (element.ToString (), m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlUpdateNodeDescription (uint32_t nodeId)
 {
   AnimXmlElement element ("nu");
@@ -2652,13 +2692,13 @@
   element.AddAttribute ("id", nodeId);
   if (m_nodeDescriptions.find (nodeId) != m_nodeDescriptions.end ())
     {
-      element.AddAttribute ("descr", m_nodeDescriptions[nodeId], true); 
+      element.AddAttribute ("descr", m_nodeDescriptions[nodeId], true);
     }
   WriteN (element.ToString (), m_f);
 }
 
 
-void 
+void
 AnimationInterface::WriteXmlUpdateNodeCounter (uint32_t nodeCounterId, uint32_t nodeId, double counterValue)
 {
   AnimXmlElement element ("nc");
@@ -2669,7 +2709,7 @@
   WriteN (element.ToString (), m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlUpdateBackground (std::string fileName, double x, double y, double scaleX, double scaleY, double opacity)
 {
   AnimXmlElement element ("bg");
@@ -2682,7 +2722,7 @@
   WriteN (element.ToString (), m_f);
 }
 
-void 
+void
 AnimationInterface::WriteXmlNonP2pLinkProperties (uint32_t id, std::string ipAddress, std::string channelType)
 {
   AnimXmlElement element ("nonp2plinkproperties");
@@ -2696,114 +2736,114 @@
 
 /***** AnimXmlElement  *****/
 
-AnimationInterface::AnimXmlElement::AnimXmlElement(std::string tagName, bool emptyElement) :
-	m_tagName(tagName),
-	m_text("")
+AnimationInterface::AnimXmlElement::AnimXmlElement (std::string tagName, bool emptyElement)
+  : m_tagName (tagName),
+    m_text ("")
 {
 }
 
 template <typename T>
 void
-AnimationInterface::AnimXmlElement::AddAttribute(std::string attribute, T value, bool xmlEscape)
+AnimationInterface::AnimXmlElement::AddAttribute (std::string attribute, T value, bool xmlEscape)
 {
-	std::ostringstream oss;
-	oss << std::setprecision(10);
-	oss << value;
-	std::string attributeString = attribute.c_str();
-	if (xmlEscape)
-	{
-		attributeString += "=\"";
-		std::string valueStr = oss.str();
-		for (std::string::iterator it = valueStr.begin(); it != valueStr.end(); ++it)
-		{
-			switch (*it)
-			{
-			case '&':
-				attributeString += "&amp;";
-				break;
-			case '\"':
-				attributeString += "&quot;";
-				break;
-			case '\'':
-				attributeString += "&apos;";
-				break;
-			case '<':
-				attributeString += "&lt;";
-				break;
-			case '>':
-				attributeString += "&gt;";
-				break;
-			default:
-				attributeString += *it;
-				break;
-			}
-		}
-		attributeString += "\" ";
-	}
-	else
-	{
-		attributeString += "=\"" + oss.str() + "\" ";
-	}
-	m_attributes.push_back(attributeString);
+  std::ostringstream oss;
+  oss << std::setprecision (10);
+  oss << value;
+  std::string attributeString = attribute.c_str ();
+  if (xmlEscape)
+    {
+      attributeString += "=\"";
+      std::string valueStr = oss.str ();
+      for (std::string::iterator it = valueStr.begin (); it != valueStr.end (); ++it)
+        {
+          switch (*it)
+            {
+            case '&':
+              attributeString += "&amp;";
+              break;
+            case '\"':
+              attributeString += "&quot;";
+              break;
+            case '\'':
+              attributeString += "&apos;";
+              break;
+            case '<':
+              attributeString += "&lt;";
+              break;
+            case '>':
+              attributeString += "&gt;";
+              break;
+            default:
+              attributeString += *it;
+              break;
+            }
+        }
+      attributeString += "\" ";
+    }
+  else
+    {
+      attributeString += "=\"" + oss.str () + "\" ";
+    }
+  m_attributes.push_back (attributeString);
 }
 
 void
-AnimationInterface::AnimXmlElement::AppendChild(AnimXmlElement e)
+AnimationInterface::AnimXmlElement::AppendChild (AnimXmlElement e)
 {
-	m_children.push_back(e.ToString());
+  m_children.push_back (e.ToString ());
 }
 
 void
-AnimationInterface::AnimXmlElement::SetText(std::string text)
+AnimationInterface::AnimXmlElement::SetText (std::string text)
 {
-	m_text = text;
+  m_text = text;
 }
 
 std::string
-AnimationInterface::AnimXmlElement::ToString(bool autoClose)
+AnimationInterface::AnimXmlElement::ToString (bool autoClose)
 {
-	std::string elementString = "<" + m_tagName + " ";
+  std::string elementString = "<" + m_tagName + " ";
 
-	
-		for (std::vector<std::string>::const_iterator i = m_attributes.begin();
-			i != m_attributes.end();
-			++i)
-		{
-			elementString += *i;
-		}
-		if (m_children.empty() && m_text.empty())
-		{
-			if (autoClose)
-			{ 
-				elementString += "/>";
-			}
-		}
-		else
-		{ 
-			elementString += ">";
-			if (!m_text.empty())
-			{
-				elementString += m_text;
-			}
-			if (!m_children.empty())
-			{
-				elementString += "\n";
-				for (std::vector<std::string>::const_iterator i = m_children.begin();
-					i != m_children.end();
-					++i)
-				{
-					elementString += *i + "\n";
-				}
-
-			}
-			if (autoClose)
-			{
-				elementString += "</" + m_tagName + ">";
-			}
-		}
 
-	
-	return elementString + ((autoClose) ?"\n": "");
+  for (std::vector<std::string>::const_iterator i = m_attributes.begin ();
+       i != m_attributes.end ();
+       ++i)
+    {
+      elementString += *i;
+    }
+  if (m_children.empty () && m_text.empty ())
+    {
+      if (autoClose)
+        {
+          elementString += "/>";
+        }
+    }
+  else
+    {
+      elementString += ">";
+      if (!m_text.empty ())
+        {
+          elementString += m_text;
+        }
+      if (!m_children.empty ())
+        {
+          elementString += "\n";
+          for (std::vector<std::string>::const_iterator i = m_children.begin ();
+               i != m_children.end ();
+               ++i)
+            {
+              elementString += *i + "\n";
+            }
+
+        }
+      if (autoClose)
+        {
+          elementString += "</" + m_tagName + ">";
+        }
+    }
+
+
+  return elementString + ((autoClose) ? "\n" : "");
 }
 
 
@@ -2866,10 +2906,10 @@
 }
 
 AnimationInterface::AnimPacketInfo::AnimPacketInfo ()
-  : m_txnd (0), 
+  : m_txnd (0),
     m_txNodeId (0),
-    m_fbTx (0), 
-    m_lbTx (0), 
+    m_fbTx (0),
+    m_lbTx (0),
     m_lbRx (0)
 {
 }
@@ -2883,20 +2923,22 @@
   m_lbRx = pInfo.m_lbRx;
 }
 
-AnimationInterface::AnimPacketInfo::AnimPacketInfo (Ptr <const NetDevice> txnd, 
-                                const Time fbTx, 
-                                uint32_t txNodeId)
-  : m_txnd (txnd), 
+AnimationInterface::AnimPacketInfo::AnimPacketInfo (Ptr <const NetDevice> txnd,
+                                                    const Time fbTx,
+                                                    uint32_t txNodeId)
+  : m_txnd (txnd),
     m_txNodeId (0),
-    m_fbTx (fbTx.GetSeconds ()), 
-    m_lbTx (0), 
+    m_fbTx (fbTx.GetSeconds ()),
+    m_lbTx (0),
     m_lbRx (0)
 {
   if (!m_txnd)
-    m_txNodeId = txNodeId;
+    {
+      m_txNodeId = txNodeId;
+    }
 }
 
-void 
+void
 AnimationInterface::AnimPacketInfo::ProcessRxBegin (Ptr<const NetDevice> nd, const double fbRx)
 {
   Ptr <Node> n = nd->GetNode ();
